## ghc 8.8.1+dfsg1+is+8.6.5+dfsg1

=== docs/core-spec/Makefile ===
OTT_FILES = CoreSyn.ott CoreLint.ott OpSem.ott
OTT_TEX   = CoreOtt.tex
OTT_OPTS  = -tex_show_meta false
TARGET    = core-spec

$(TARGET).pdf: $(TARGET).tex $(OTT_TEX)
	latex -output-format=pdf $<
	latex -output-format=pdf $<

$(TARGET).tex: $(TARGET).mng $(OTT_FILES)
	ott $(OTT_OPTS) -tex_filter $< $@ $(OTT_FILES)

$(OTT_TEX): $(OTT_FILES)
	ott -tex_wrap false $(OTT_OPTS) -o $@ $^

.PHONY: clean
clean:
	rm -f $(TARGET).pdf $(TARGET).tex $(OTT_TEX) *.aux *.fdb_latexmk *.log *.fls

=== docs/stg-spec/Makefile ===
OTT_FILES = StgSyn.ott CostSem.ott
OTT_TEX   = StgOtt.tex
OTT_OPTS  = -tex_show_meta false
TARGET    = stg-spec

$(TARGET).pdf: $(TARGET).tex $(OTT_TEX)
	latex -output-format=pdf $<
	latex -output-format=pdf $<

$(TARGET).tex: $(TARGET).mng $(OTT_FILES)
	ott $(OTT_OPTS) -tex_filter $< $@ $(OTT_FILES)

$(OTT_TEX): $(OTT_FILES)
	ott -tex_wrap false $(OTT_OPTS) -o $@ $^

.PHONY: clean
clean:
	rm -f $(TARGET).pdf $(TARGET).tex $(OTT_TEX) *.aux *.fdb_latexmk *.log

=== libraries/Cabal/Makefile ===
.PHONY : all lexer sdpx lib exe doctest
.PHONY : gen-extra-source-files gen-extra-source-files-lib gen-extra-source-files-cli
.PHONY : cabal-install-dev cabal-install-prod

LEXER_HS:=Cabal/Distribution/Parsec/Lexer.hs
SPDX_LICENSE_HS:=Cabal/Distribution/SPDX/LicenseId.hs
SPDX_EXCEPTION_HS:=Cabal/Distribution/SPDX/LicenseExceptionId.hs

all : exe lib

lexer : $(LEXER_HS)

spdx : $(SPDX_LICENSE_HS) $(SPDX_EXCEPTION_HS)

$(LEXER_HS) : boot/Lexer.x
	alex --latin1 --ghc -o $@ $^
	cat -s $@ > Lexer.tmp
	mv Lexer.tmp $@

$(SPDX_LICENSE_HS) : boot/SPDX.LicenseId.template.hs cabal-dev-scripts/src/GenUtils.hs cabal-dev-scripts/src/GenSPDX.hs license-list-data/licenses-3.0.json license-list-data/licenses-3.2.json
	cabal new-run --builddir=dist-newstyle-meta --project-file=cabal.project.meta gen-spdx -- boot/SPDX.LicenseId.template.hs license-list-data/licenses-3.0.json license-list-data/licenses-3.2.json $(SPDX_LICENSE_HS)

$(SPDX_EXCEPTION_HS) : boot/SPDX.LicenseExceptionId.template.hs cabal-dev-scripts/src/GenUtils.hs cabal-dev-scripts/src/GenSPDXExc.hs license-list-data/exceptions-3.0.json license-list-data/exceptions-3.2.json
	cabal new-run --builddir=dist-newstyle-meta --project-file=cabal.project.meta gen-spdx-exc -- boot/SPDX.LicenseExceptionId.template.hs license-list-data/exceptions-3.0.json license-list-data/exceptions-3.2.json $(SPDX_EXCEPTION_HS)

cabal-install-prod : cabal-install/cabal-install.cabal.pp
	runghc cabal-dev-scripts/src/Preprocessor.hs -o cabal-install/cabal-install.cabal cabal-install/cabal-install.cabal.pp
	git update-index --no-assume-unchanged cabal-install/cabal-install.cabal

cabal-install-dev : cabal-install/cabal-install.cabal.pp
	runghc cabal-dev-scripts/src/Preprocessor.hs -o cabal-install/cabal-install.cabal -f CABAL_FLAG_LIB cabal-install/cabal-install.cabal.pp
	@echo "tell git to ignore changes to cabal-install.cabal:"
	@echo "git update-index --assume-unchanged cabal-install/cabal-install.cabal"

cabal-install-monolithic : cabal-install/cabal-install.cabal.pp
	runghc cabal-dev-scripts/src/Preprocessor.hs -o cabal-install/cabal-install.cabal -f CABAL_FLAG_LIB -f CABAL_FLAG_MONOLITHIC cabal-install/cabal-install.cabal.pp
	@echo "tell git to ignore changes to cabal-install.cabal:"
	@echo "git update-index --assume-unchanged cabal-install/cabal-install.cabal"

lib : $(LEXER_HS)
	cabal new-build --enable-tests Cabal

exe : $(LEXER_HS)
	cabal new-build --enable-tests cabal-install

doctest :
	doctest --fast Cabal/Distribution Cabal/Language

gen-extra-source-files : gen-extra-source-files-lib gen-extra-source-files-cli

gen-extra-source-files-lib :
	cabal new-run --builddir=dist-newstyle-meta --project-file=cabal.project.meta gen-extra-source-files -- $$(pwd)/Cabal/Cabal.cabal

# We need to generate cabal-install-dev so the test modules are in .cabal file!
gen-extra-source-files-cli :
	$(MAKE) cabal-install-dev
	cabal new-run --builddir=dist-newstyle-meta --project-file=cabal.project.meta gen-extra-source-files -- $$(pwd)/cabal-install/cabal-install.cabal.pp $$(pwd)/cabal-install/cabal-install.cabal
	$(MAKE) cabal-install-prod

cabal-install-test:
	cabal new-build -j3 all --disable-tests --disable-benchmarks
	rm -rf .ghc.environment.*
	cd cabal-testsuite && `cabal-plan list-bin cabal-tests` --with-cabal=`cabal-plan list-bin cabal` --hide-successes -j3 ${TEST}

=== utils/hp2ps/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = utils/hp2ps
TOP = ../..
include $(TOP)/mk/sub-makefile.mk

=== utils/runghc/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = utils/runghc
TOP = ../..
include $(TOP)/mk/sub-makefile.mk

=== utils/touchy/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

#
# Substitute for 'touch' on win32 platforms (without an Unix toolset installed).
#
TOP=../..
include $(TOP)/mk/boilerplate.mk

C_SRCS=touchy.c
C_PROG=touchy
SRC_CC_OPTS += -O

#
# Install touchy in lib/.*
#
INSTALL_LIBEXECS += $(C_PROG)

include $(TOP)/mk/target.mk

# Get it over with!
boot :: all

binary-dist:
	$(INSTALL_DIR)               $(BIN_DIST_DIR)/utils/touchy
	$(INSTALL_DATA)    Makefile  $(BIN_DIST_DIR)/utils/touchy/
	$(INSTALL_PROGRAM) $(C_PROG) $(BIN_DIST_DIR)/utils/touchy/

=== libraries/Cabal/Cabal/Makefile ===

VERSION=2.4.0.1

#KIND=devel
KIND=rc
#KIND=cabal-latest

PREFIX=/usr/local
HC=ghc
GHCFLAGS=-Wall -threaded
SSH_USER=$(USER)

all: build

# build the library itself

SOURCES=Distribution/*.hs Distribution/Simple/*.hs \
	Distribution/PackageDescription/*.hs Distribution/Simple/GHC/*.hs \
	Distribution/Simple/Build/*.hs Distribution/Compat/*.hs \
	Distribution/Simple/Program/*.hs
CONFIG_STAMP=dist/setup-config
BUILD_STAMP=dist/build/libHSCabal-$(VERSION).a
HADDOCK_STAMP=dist/doc/html/Cabal/index.html
USERGUIDE_STAMP=dist/doc/users-guide/index.html
SDIST_STAMP=dist/Cabal-$(VERSION).tar.gz
DISTLOC=dist/release
DIST_STAMP=$(DISTLOC)/Cabal-$(VERSION).tar.gz
SPHINXCMD:=$(shell command -v sphinx-build2 2> /dev/null)
ifndef SPHINXCMD
	SPHINXCMD:=$(shell command -v sphinx-build 2> /dev/null)
endif
ifndef SPHINXCMD
	$(error "needs sphinx-build")
endif


COMMA=,

setup: $(SOURCES) Setup.hs
	-mkdir -p dist/setup
	$(HC) $(GHCFLAGS) --make -i. -odir dist/setup -hidir dist/setup Setup.hs \
		-o setup

$(CONFIG_STAMP): setup Cabal.cabal
	./setup configure --with-compiler=$(HC) --prefix=$(PREFIX)

build: $(BUILD_STAMP)
$(BUILD_STAMP): $(CONFIG_STAMP) $(SOURCES)
	./setup build

install: $(BUILD_STAMP)
	./setup install

# documentation...

haddock: $(HADDOCK_STAMP)
$(HADDOCK_STAMP) : $(CONFIG_STAMP) $(BUILD_STAMP)
	./setup haddock

SPHINX_HTML_OUTDIR=dist/doc/users-guide

users-guide: $(USERGUIDE_STAMP)
$(USERGUIDE_STAMP) : doc/*.rst
	mkdir -p $(SPHINX_HTML_OUTDIR)
	$(SPHINXCMD) doc $(SPHINX_HTML_OUTDIR)

docs: haddock users-guide

clean:
	rm -rf dist/
	rm -f setup

# testing...

moduleTest: tests/ModuleTest.hs tests/PackageDescriptionTests.hs
	mkdir -p dist/test
	$(HC) --make -Wall -DDEBUG -odir dist/test -hidir dist/test \
		-itests tests/ModuleTest.hs -o moduleTest

#tests: moduleTest clean
#	cd tests/A && $(MAKE) clean
#	cd tests/HUnit-1.0 && $(MAKE) clean
#	cd tests/A && $(MAKE)
#	cd tests/HUnit-1.0 && $(MAKE)

#check:
#	rm -f moduleTest
#	$(MAKE) moduleTest
#	./moduleTest

# distribution...

$(SDIST_STAMP) : $(BUILD_STAMP)
	./setup sdist

dist: $(DIST_STAMP)
$(DIST_STAMP) : $(HADDOCK_STAMP) $(USERGUIDE_STAMP) $(SDIST_STAMP)
	rm -rf $(DISTLOC)
	mkdir $(DISTLOC)
	tar -xzf $(SDIST_STAMP) -C $(DISTLOC)/
	mkdir -p $(DISTLOC)/Cabal-$(VERSION)/doc
	cp -r dist/doc/html $(DISTLOC)/Cabal-$(VERSION)/doc/API
	cp -r dist/doc/users-guide $(DISTLOC)/Cabal-$(VERSION)/doc/
	cp ChangeLog.md $(DISTLOC)/Cabal-$(VERSION)/
	tar --format=ustar -C $(DISTLOC) -czf $(DISTLOC)/Cabal-$(VERSION).tar.gz Cabal-$(VERSION)
	mkdir $(DISTLOC)/doc
	mv $(DISTLOC)/Cabal-$(VERSION)/doc/users-guide $(DISTLOC)/doc
	mv $(DISTLOC)/Cabal-$(VERSION)/doc/API $(DISTLOC)/doc
	mv $(DISTLOC)/Cabal-$(VERSION)/ChangeLog.md $(DISTLOC)/
	rm -r $(DISTLOC)/Cabal-$(VERSION)/
	@echo "Cabal tarball built: $(DIST_STAMP)"
	@echo "Release fileset prepared: $(DISTLOC)/"

# Out of date, use SFTP
#release: $(DIST_STAMP)
#	scp -r $(DISTLOC) $(SSH_USER)@haskell.org:/home/web/haskell.org/cabal/release/cabal-$(VERSION)
#	ssh $(SSH_USER)@haskell.org 'cd /home/web/haskell.org/cabal/release && rm -f $(KIND) && ln -s cabal-$(VERSION) $(KIND)'

# tags...

TAGSSRCDIRS = Distribution Language
tags TAGS: $(SOURCES)
	find $(TAGSSRCDIRS) -name \*.\*hs | xargs hasktags

=== libraries/base/codepages/Makefile ===

.PHONY: default
default:
	$(MAKE) getCodepages
	$(MAKE) genTable

.PHONY: getCodepages
getCodepages:
	rm -rf www.unicode.org
	rm -rf CPs
	mkdir CPs
	wget -r -np http://www.unicode.org/Public/MAPPINGS/VENDORS/MICSFT/
	find www.unicode.org -name 'CP*' -exec cp {} CPs \;

.PHONY: genTable
genTable:
	ghc --make MakeTable
	./MakeTable GHC.IO.Encoding.CodePage.Table ../GHC/IO/Encoding/CodePage/Table.hs CPs/*

=== libraries/bytestring/tests/Makefile ===
GHC=            ghc
GHCFLAGS=       -cpp -O2 -funbox-strict-fields -v0 -fglasgow-exts -O2 -funbox-strict-fields -fdicts-cheap -fno-method-sharing -fmax-simplifier-iterations10 -fcpr-off

#PKG=            -package fps

#GHC=            /usr/obj/build/compiler/stage2/ghc-inplace
#PKG=            

BIN=            run-utests run-qtests

all:  prop prop-fusion-compiled prop-compiled prop-opt units-compiled
fast: prop-fast

everything: prop hugs prop-compiled prop-fusion-compiled runbench fusionbench wc spellcheck letter_frequency linesort fuse down-fuse inline zipwith unpack groupby run-lazybuild run-lazybuildcons run-lazyread

# ---------------------------------------------
# Boot in-place

.PHONY: boot-in-place

boot-in-place:
	cd .. && ${GHC} ${GHCFLAGS} --make Data/*hs Data/*/*hs Data/*/*/*hs

# ---------------------------------------------
# HUnit

# compiled
.PHONY: units-compiled
units-compiled:
	@echo "Compiled, rules off"
	${GHC} ${PKG} ${GHCFLAGS} -fno-rewrite-rules --make Units.hs -o u -package HUnit
	time ./u

# ---------------------------------------------
# ByteString Builders

hpc-builder: dist/build/test-builder/test-builder
	rm -f test-builder.tix
	dist/build/test-builder/test-builder
	hpc markup test-builder.tix



# ---------------------------------------------
# QuickCheck

# interpreted
.PHONY: prop hugs
prop:: 
	@echo "Interpreted"	
	runhaskell -i../cbits/fpstring.o Properties.hs

hugs::
	runhugs -98 Properties.hs

# interpreted fast. Just a quick check.
.PHONY: prop-fast
prop-fast::
	runhaskell -i../cbits/fpstring.o Properties.hs 30 

# compiled
.PHONY: prop-compiled
prop-compiled: 
	@echo "Compiled, rules off"	
	${GHC} ${PKG} ${GHCFLAGS} -fno-rewrite-rules --make Properties.hs -o p -package QuickCheck
	time ./p

# rules-on
.PHONY: prop-opt
prop-opt: 
	@echo "Compiled, rules on"	
	${GHC} ${PKG} ${GHCFLAGS} --make Properties.hs -o p -package QuickCheck
	time ./p

# rules-on
.PHONY: hpc-lite
hpc-lite: 
	@echo "Compiled, rules on, with hpc"	
	rm -f p.tix
	${GHC} ${GHCFLAGS} ../dist/build/cbits/fpstring.o -ddump-simpl-stats -fhpc --make -i.. Properties.hs -o p -O -fno-ignore-asserts -fasm -frewrite-rules
	rm Rules.o Rules.hi
	${GHC} ${GHCFLAGS} -hide-package bytestring ../dist/build/cbits/fpstring.o -ddump-simpl-stats -i.. Rules.hs -O -fno-ignore-asserts -fasm -frewrite-rules ../Data/ByteString/*.o ../Data/ByteString/*/*.o ../Data/ByteString.o -package QuickCheck QuickCheckUtils.o -c -no-recomp
	${GHC} ${GHCFLAGS} -package QuickCheck ../dist/build/cbits/fpstring.o Properties.o Rules.o QuickCheckUtils.o ../Data/ByteString/*.o ../Data/ByteString/*/*.o ../Data/ByteString.o -o p
	time ./p 40
	hpc markup p --exclude=Main --exclude=QuickCheckUtils --exclude=Data.ByteString.Fusion

#
# test rewriting is correct and working.
#
.PHONY: prop-fusion-compiled
prop-fusion-compiled:
	${GHC} ${PKG} ${GHCFLAGS} --make FusionProperties.hs -o fp -package QuickCheck
	time ./fp

# ---------------------------------------------------------
# Benchmarking

.PHONY: runbench
runbench: bench
	./bench +RTS -H64m

bench::
	@if [ ! -f "bigdata" ] ; then ln -s data bigdata ; fi
	${GHC} ${PKG} ${GHCFLAGS} --make Bench.hs -o bench

fusionbench::
	${GHC} ${PKG} ${GHCFLAGS} --make FusionBench.hs -ddump-simpl-stats -o fusionbench

# ---------------------------------------------------------
# Profiling
.PHONY: prof

prof::
	@if [ ! -f "bigdata" ] ; then ln -s data bigdata ; fi
	${GHC} ${PKG} ${GHCFLAGS} -prof -fprof-auto --make Bench.hs -o bench
	./bench +RTS -H64m -p

fusionprof::
	@if [ ! -f "bigdata" ] ; then ln -s data bigdata ; fi
	${GHC} ${PKG} ${GHCFLAGS} -prof -fprof-auto --make FusionBench.hs -o fusionbench
	./bench +RTS -H64m -p

# ---------------------------------------------------------
# Small programs

wc: wc.o
	@if [ ! -f "bigdata" ] ; then ln -s data bigdata ; fi
	time ./wc bigdata
wc.o: wc.hs
	${GHC} ${PKG} ${GHCFLAGS} --make -ddump-simpl-stats wc.hs -o wc

spellcheck: spellcheck.o
	time ./spellcheck < spellcheck-input.txt
spellcheck.o: spellcheck.hs
	${GHC} ${PKG} ${GHCFLAGS} --make $< -o spellcheck

letter_frequency: letter_frequency.o
	time ./letter_frequency < Usr.Dict.Words
letter_frequency.o: letter_frequency.hs
	${GHC} ${PKG} ${GHCFLAGS} --make  $< -o letter_frequency -ddump-simpl-stats

linesort: linesort.o
	time ./linesort < Usr.Dict.Words
linesort.o: linesort.hs
	${GHC} ${PKG} ${GHCFLAGS} --make  $< -o linesort

fuse: fuse.o
	time ./fuse < Usr.Dict.Words
fuse.o: fuse.hs
	${GHC} ${PKG} ${GHCFLAGS} --make $< -o fuse -ddump-simpl-stats

down-fuse: down-fuse.o
	time ./down-fuse
down-fuse.o: down-fuse.hs
	${GHC} ${PKG} ${GHCFLAGS} --make $< -o ./down-fuse -ddump-simpl-stats

.PHONY: run-lazybuild
run-lazybuild: lazybuild
	time ./lazybuild 100000000 > /dev/null
lazybuild: lazybuild.hs
	${GHC} ${PKG} ${GHCFLAGS} --make $< -o lazybuild

.PHONY: run-lazybuildcons
run-lazybuildcons: lazybuildcons
	time ./lazybuildcons 100000000 > /dev/null
lazybuildcons: lazybuildcons.hs
	${GHC} ${PKG} ${GHCFLAGS} --make $< -o lazybuildcons

.PHONY: run-lazyread
run-lazyread: lazyread
	./lazyread > /dev/null
lazyread: lazyread.hs
	${GHC} ${PKG} ${GHCFLAGS} --make $< -o lazyread

lazylines: lazylines.o
	time ./lazylines < bigdata
lazylines.o: lazylines.hs
	${GHC} ${PKG} ${GHCFLAGS} --make $< -o lazylines

inline: inline.o
	time ./inline
inline.o: inline.hs
	${GHC} ${PKG} ${GHCFLAGS} --make $< -o inline

zipwith: zipwith.o
	time ./zipwith
zipwith.o: zipwith.hs
	${GHC} ${PKG} ${GHCFLAGS} --make -ddump-simpl-stats $< -o zipwith

unpack: unpack.o
	time ./unpack
unpack.o: unpack.hs
	${GHC} ${PKG} ${GHCFLAGS} --make -ddump-simpl-stats $< -o unpack

groupby: groupby.o
	time ./groupby
groupby.o: groupby.hs
	${GHC} ${PKG} ${GHCFLAGS} --make $< -o groupby

# ---------------------------------------------------
# Plotting graphs

results: bench
	./bench +RTS -H64m > results

.PHONY: plot
plot:: results
	echo -e 'set terminal png          \n \
             set output "results.png"  \n \
             set yrange [0:2]          \n \
             plot "results" using ($$1):($$2) with boxes, "" using ($$1):($$3) with boxes' |\
             gnuplot ;
	xv results.png    

# ---------------------------------------------------
# Cleaning

.PHONY: clean
clean:
	rm -f *~ *.o *.hi $(BIN) bench */*.o */*.hi */*~ 
	rm -f wc letter_frequency spellcheck linesort fuse inline p u fp lazylines lazybuild lazybuildcons
	rm -f down-fuse zipwith fusionbench unpack groupby
	rm -rf *.tix *.html .hpc check

=== libraries/containers/benchmarks/SetOperations/Makefile ===
TOP = ../

include ../Makefile

=== debian/changelog ===
ghc (8.8.1+dfsg1+is+8.6.5+dfsg1-3) unstable; urgency=medium

  * Switch to python3-sphinx; Closes: #943097

 -- Sandro Tosi <morph@debian.org>  Mon, 23 Mar 2020 21:50:31 -0400

ghc (8.8.1+dfsg1+is+8.6.5+dfsg1-2) unstable; urgency=medium

  [ John Paul Adrian Glaubitz ]
  * Enable workaround to avoid memory exhaustation on alpha
  [ Gianfranco Costamagna ]
  * Source-only reupload now that the bootstrap has ended

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 21 Sep 2019 12:06:31 +0200

ghc (8.8.1+dfsg1+is+8.6.5+dfsg1-1) unstable; urgency=medium

  [ John Paul Adrian Glaubitz ]
  * Enable workaround to avoid memory exhaustation on m68k and sh4
  [ Gianfranco Costamagna ]
  * 8.8.1+dfsg1-1~exp4 was mistakenly targeted to unstable.
    - use 8.6.5 repacked tarball to fix the issue

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 12 Sep 2019 08:25:57 +0200

=== debian/control ===
Source: ghc
Section: haskell
Priority: optional
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders: Joachim Breitner <nomeata@debian.org>, Clint Adams <clint@debian.org>
Standards-Version: 4.4.0
Rules-Requires-Root: no
Build-Depends:
  debhelper (>= 10),
  haskell-devscripts-minimal <!cross>,
  devscripts,
  grep-dctrl,
  pkg-config,
  ghc:native (>= 8.4),
  libgmp-dev,
  llvm-6.0 [arm64 armel armhf],
  libffi-dev,
  libncurses5-dev,
  python3-sphinx <!cross>,
  dpkg-dev (>= 1.16.1.1)
Build-Depends-Indep:
  hscolour,
  fop
Build-Conflicts: ccache
Homepage: https://haskell.org/ghc/
Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/ghc]
Vcs-Browser: https://salsa.debian.org/haskell-team/DHG_packages/tree/master/p/ghc

Package: ghc
Architecture: any
Depends:
  llvm-6.0 [arm64 armel armhf],
  gcc,
  libgmp-dev,
  libffi-dev,
  libbsd-dev,
  libc6-dev,
  libncurses5-dev,
  ${shlibs:Depends},
  ${misc:Depends}
Pre-Depends: dpkg (>= 1.16.1)
Provides:
  haskell-compiler,
  ghc-dynamic,
  ${ghci},
  ${provided-devs},
  ${haskell:Provides},
  haddock,
  ghc-haddock,
  ${haddock:Provides}
Replaces: ghc6 (<< 7), ghc-dynamic (<< 7.8), ghc-haddock (<< 7.10), ${conflicting-devs}
Conflicts: ghc6 (<< 7), ghc-dynamic (<< 7.8)
Breaks: cabal-install (<< 1.22), haskell-devscripts (<< 0.8.13),
 ghc-doc (<< 7.10), ghc-haddock (<< 7.10), ${conflicting-devs}
Suggests: perl, ghc-prof, ghc-doc, haskell-doc, llvm-6.0
Description: The Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.

Package: ghc-prof
Architecture: any
Provides: ${provided-profs}, ${haskell:Provides}
Depends: ghc (= ${binary:Version}), ${misc:Depends}
Replaces: ghc6-prof (<< 7)
Conflicts: ghc6-prof (<< 7)
Description: Profiling libraries for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package contains additional profiling libraries. They are only needed,
 if you want to take a closer look on where exactly your program burns CPU
 cycles.

Package: ghc-doc
Section: doc
Architecture: all
Suggests: haskell-doc
Provides: ${provided-docs}
Replaces: ghc6-doc (<< 7), libghc-terminfo-doc (<< 0.3.2.5-4), libghc-transformers-doc (<< 0.3.0.0-6), libghc-xhtml-doc (<< 3000.2.1-5)
Conflicts: ghc6-doc (<< 7), ghc (<= 7.0.3-1)
Breaks: libghc-terminfo-doc (<< 0.3.2.5-4), libghc-transformers-doc (<< 0.3.0.0-6), libghc-xhtml-doc (<< 3000.2.1-5)
Depends: ${haddock:Depends}, ${misc:Depends}, perl, libjs-mathjax
Pre-Depends: dpkg (>= 1.16.1)
Description: Documentation for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package includes HTML, DVI and PS versions of the SGML-based
 documentation around GHC.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# This file is public domain software, originally written by Joey Hess.
#
# This version is for a multibinary package. It also allows you to build any
# of the binary packages independantly, via binary-<package> targets.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# # Set default flags with dpkg-buildflags
# # This might also close #712228
# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# DPKG_EXPORT_BUILDFLAGS = 1
# include /usr/share/dpkg/buildflags.mk

# Set a dummy HOME variable upon build. Some build daemons do not set HOME, but
# ghc-cabal expects it to be available.
export HOME = /homedoesnotexistatbuildtime

# From /usr/share/doc/autotools-dev/examples/rules.gz:
export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
export DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
export DEB_TARGET_ARCH_ENDIAN	?= $(shell dpkg-architecture -qDEB_TARGET_ARCH_ENDIAN)

# We're cross-building if DEB_BUILD_GNU_TYPE != DEB_HOST_GNU_TYPE
ifneq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  EXTRA_CONFIGURE_FLAGS += --host $(DEB_BUILD_GNU_TYPE) --build $(DEB_BUILD_GNU_TYPE) --target $(DEB_HOST_GNU_TYPE) --enable-unregisterised
  BUILD_CROSS=YES
else
  EXTRA_CONFIGURE_FLAGS += --target $(DEB_HOST_GNU_TYPE)
  BUILD_CROSS=NO
endif

ProjectVersion=$(shell cat VERSION)

GHC=$(firstword $(shell bash -c "type -p ghc"))
EXTRA_CONFIGURE_FLAGS +=--with-ghc="$(GHC)"

DEB_HOOGLE_TXT_DIR = /usr/lib/ghc-doc/hoogle/

ifneq (,$(filter powerpcspe x32, $(DEB_HOST_ARCH)))
  EXTRA_CONFIGURE_FLAGS += --enable-unregisterised
endif

# Use system's default ld (ld.bfd) rather than ld.gold, which fails for
# haskell-cryptohash-sha256 on mips/mipsel. For more information, see
# https://bugs.debian.org/901947
# NOTE: This should probably be removed, and revert back to using ld.gold,
# once #901947 has been fixed.
# Do the same for powerpcspe, due to https://bugs.debian.org/904915
# Do the same for sparc64, due to https://bugs.debian.org/908998
ifneq (,$(filter mips mipsel powerpc powerpcspe sparc64, $(DEB_HOST_ARCH)))
  EXTRA_CONFIGURE_FLAGS += --disable-ld-override
endif

%:
ifneq (,$(filter s390x, $(DEB_HOST_ARCH)))
	# Build fails with out-of-memory on Ubuntu's s390x builders.
	# Setting `ggc-min-expand=10` doesn't solve this.
	# For now, reduce number of parallel jobs.
	dh $@ --max-parallel=2
else
	dh $@
endif


override_dh_autoreconf:
	dh_autoreconf perl -- boot

override_dh_auto_configure:
	echo "SRC_HC_OPTS += -lffi -optl-pthread" >> mk/build.mk
ifeq (NO,$(BUILD_CROSS))
	echo "HADDOCK_DOCS := YES" >> mk/build.mk
	echo "EXTRA_HADDOCK_OPTS += --mathjax=file:///usr/share/javascript/mathjax/MathJax.js" >> mk/build.mk
	echo "XSLTPROC_OPTS += --nonet" >> mk/build.mk
else
	echo "SRC_HC_OPTS += -O0 -H64m" >> mk/build.mk
	echo "GhcStage1HcOpts = -O" >> mk/build.mk
	echo "GhcStage2HcOpts = -O0" >> mk/build.mk
	echo "GhcLibHcOpts = -O" >> mk/build.mk
	echo "SplitObjs = NO" >> mk/build.mk
	echo "HADDOCK_DOCS := NO" >> mk/build.mk
	echo "BUILD_SPHINX_HTML := NO" >> mk/build.mk
	echo "BUILD_SPHINX_PDF := NO" >> mk/build.mk
endif
ifeq (armhf,$(DEB_HOST_ARCH))
	echo "SRC_HC_OPTS += -D__ARM_PCS_VFP" >> mk/build.mk
endif
ifeq (big, $(DEB_TARGET_ARCH_ENDIAN))
	# See https://gitlab.haskell.org/ghc/ghc/issues/16998
	patch -p1 < debian/patches/Disable-unboxed-arrays.patch
endif
ifneq (,$(filter mips mipsel mips64el s390x, $(DEB_HOST_ARCH)))
	echo "SRC_HC_OPTS     += -optc--param -optcggc-min-expand=10" >> mk/build.mk
endif
ifneq (,$(filter mips64el, $(DEB_HOST_ARCH)))
	# Pass -mxgot to fix relocation linker errors
	echo "compiler/hsSyn/HsInstances_HC_OPTS += -optc-mxgot" >> mk/build.mk
endif
ifeq (x32,$(DEB_HOST_ARCH))
	echo "INTEGER_LIBRARY = integer-simple" >> mk/build.mk
endif
ifneq (,$(filter nostrip, $(DEB_BUILD_OPTIONS)))
#	echo "GhcStage1HcOpts += -DDEBUG" >> mk/build.mk
#	echo "GhcStage2HcOpts += -DDEBUG" >> mk/build.mk
	echo "SRC_HC_OPTS   += -H32m -O0" >> mk/build.mk
	echo "GhcHcOpts     += -Rghc-timing -DDEBUG" >> mk/build.mk
#	echo "GhcLibHcOpts  += -O -dcore-lint -keep-hc-files " >> mk/build.mk
	echo "SplitObjs     = NO" >> mk/build.mk
	echo "STRIP         = :" >> mk/build.mk
endif
ifneq (,$(filter noopt, $(DEB_BUILD_OPTIONS)))
	echo "SRC_HC_OPTS   += -H32m -O0" >> mk/build.mk
	echo "GhcHcOpts     += -O0" >> mk/build.mk
	# This breaks the build - to be investigated:
	# echo "GhcLibHcOpts  += -O0" >> mk/build.mk
	echo "GhcRtsCcOpts  += -O0" >> mk/build.mk
endif
ifneq (,$(filter alpha m68k mipsel hppa sh4 x32, $(DEB_HOST_ARCH)))
	# Virtual memory exhausted when trying to build unregisterised compiler on
	# 32-bit targets. Disable optimizations for compiler/hsSyn/HsInstances.hs.
	# See https://bugs.debian.org/933968
	# See https://gitlab.haskell.org/ghc/ghc/issues/17048
	echo "compiler/hsSyn/HsInstances_HC_OPTS += -O0" >> mk/build.mk
endif
	# We also want to build the threaded profiling-enabled debug runtime,
	# because it does no harm
	echo 'GhcRTSWays += $$(if $$(filter p, $$(GhcLibWays)),thr_debug_p,)' >> mk/build.mk

	# We can't do this with a configure flag in 6.8.1 as libdir is not
	# defined at the point at which we := it
	echo 'ghclibdir := $${libdir}/ghc' >> mk/build.mk
	echo 'bindir  := /usr/bin' >> mk/build.mk
	# docdir doesn't have a configure flag, and unfortunately
	# we also need to explicitly define all of its dependents as they
	# are set with :=
	echo 'docdir  := $$(datarootdir)/doc/ghc-doc' >> mk/build.mk
	echo 'htmldir := $$(docdir)'                   >> mk/build.mk
	echo 'dvidir  := $$(docdir)'                   >> mk/build.mk
	echo 'pdfdir  := $$(docdir)'                   >> mk/build.mk
	echo 'psdir   := $$(docdir)'                   >> mk/build.mk
	echo 'STRIP_CMD = $(DEB_HOST_GNU_TYPE)-strip'  >> mk/build.mk
	echo 'RANLIB_CMD = $(DEB_HOST_GNU_TYPE)-ranlib'>> mk/build.mk
	# We want verbose builds
	echo 'V=1'                                     >> mk/build.mk
	dh_auto_configure -- \
		$(EXTRA_CONFIGURE_FLAGS) \
		--with-system-libffi --libdir=/usr/lib

override_dh_auto_build:
	dh_auto_build

override_dh_auto_test:
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	# Do some very simple tests that the compiler actually works
	rm -rf debian/testghc
	mkdir debian/testghc
	echo 'main = putStrLn "Foo"' > debian/testghc/foo.hs
	inplace/bin/ghc-stage2 debian/testghc/foo.hs -o debian/testghc/foo
	[ "$$(debian/testghc/foo)" = "Foo" ]
	rm debian/testghc/*
	echo 'main = putStrLn "Foo"' > debian/testghc/foo.hs
	inplace/bin/ghc-stage2 debian/testghc/foo.hs -o debian/testghc/foo -O2
	[ "$$(debian/testghc/foo)" = "Foo" ]
	rm debian/testghc/*
	@printf "====BEGIN GHC INFO OUTPUT====\n"
	@inplace/bin/ghc-stage2 --info
	@printf "====END GHC INFO OUTPUT====\n"
endif

FILES = \( -type f -o -type l \)
PROF_FILE = \( -name "*.p_*" -o -name "lib*_p.a" \)

override_dh_auto_install:
	dh_auto_install

	# Delete all the library LICENSE files
	rm -f debian/tmp/usr/share/doc/ghc-doc/html/libraries/*/LICENSE

	# Remove the haddock.t files, they really should not be in the released
	# package (upstream #10410)
	find debian/tmp -name \*.haddock.t -delete

	# Generate lintian overrides
	mkdir -p debian/tmp/usr/share/lintian/overrides
	echo "ghc binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc/Cabal-*/Distribution/License.hi`" >> debian/tmp/usr/share/lintian/overrides/ghc
	echo "ghc: extra-license-file `cd debian/tmp && echo usr/lib/ghc/Cabal-*/Distribution/License.dyn_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc
	echo "ghc-prof binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc/Cabal-*/Distribution/License.p_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc-prof

	# Sort out the package.conf files
	mkdir -p debian/tmp/var/lib/ghc
	# Old directories for symlink-workaround. Remove once all libraries use new path
	mv debian/tmp/usr/lib/ghc/package.conf.d \

## ghc 8.8.3

=== debian/changelog ===
ghc (8.8.3-1ubuntu2) groovy; urgency=medium

  * Fix ByteOrder on s390x.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 14 Jul 2020 13:06:27 +0100

ghc (8.8.3-1ubuntu1) groovy; urgency=medium

  * Also reduce parallel builds on arm64

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 27 May 2020 17:46:58 +0200

ghc (8.8.3-1) unstable; urgency=medium

  * Upload to unstable.

 -- Sean Whitton <spwhitton@spwhitton.name>  Tue, 26 May 2020 09:45:34 -0700

ghc (8.8.3-1~exp2) experimental; urgency=medium

  * Patch to remove hs_atomic{read,write}64 from non-64bit systems.
    This fixes compilation on mipsel and powerpc.

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Sun, 01 Mar 2020 19:01:10 +0200

ghc (8.8.3-1~exp1) experimental; urgency=medium

  * New upstream release
  * Do not pass ggc-min-expand=10 on mips64el
  * Remove unnecessary build-dependency on alex
  * Replace python-sphinx build-dependency with python3-sphinx
    (Closes: #943097)
  * Allow unregisterised ghc-8.6 to build newer GHC
  * Fix wrong installation of ghc-<version> manpages
  * Bump compat level to 12
  * Use the debhelper-compat build-dependency and remove d/compat
  * Update to llvm-9 (Closes: #912788)

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Fri, 28 Feb 2020 10:56:27 +0200

ghc (8.8.2-1~exp1) experimental; urgency=medium

  * New upstream release
  * Upload to experimental.
  * Bump std-version to 4.5.0, no changes required
  * Drop the dfsg code, the current version doesn't bundle anymore that
    library
  * Apply changes from 8.8.1+dfsg1+is+8.6.5+dfsg1-2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 28 Jan 2020 08:58:32 +0100

ghc (8.8.1+dfsg2-1~exp1) experimental; urgency=medium

  * That one was for experimental, reupload as dfsg2 to bump version

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 12 Sep 2019 08:18:56 +0200

ghc (8.8.1+dfsg1-1~exp4) unstable; urgency=medium

  * Probably llvm-7 is the last working version that can be used in arm

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 11 Sep 2019 12:04:25 +0200

ghc (8.8.1+dfsg1-1~exp3) experimental; urgency=medium

  * Stick with llvm-8, because llvm-9 seems to be not able to make the build
    finish correctly (error during the compile of a test program in ghc
    testsuite)
  * Comment patch fix-build-using-unregisterized-v8.4: we are using 8.6.5
    to bootstrap 8.8.1

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 11 Sep 2019 08:55:51 +0200

ghc (8.8.1+dfsg1-1~exp2) experimental; urgency=medium

  * Followup upstream change in ghc configure script to fix a configure error
  * Depend on alex
  * Refresh s390x patch

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 10 Sep 2019 17:37:37 +0200

ghc (8.8.1+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release, patch refresh
  * Drop upstream patches:
    - bsymbolic-only-for-registerised.patch
    - e175aaf6918bb2b497b83618dc4c270a0d231a1c.patch
    - add_-latomic_to_ghc-prim 
    - risc-support.patch
    - PprC-Add-support-for-adjacent-floats
    - powerpc-fix-64-bit-comparision.patch
  * Switch to default llvm version

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 10 Sep 2019 12:53:10 +0200

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,20 @@
 Source: ghc
 Section: haskell
 Priority: optional
-Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
 Uploaders: Joachim Breitner <nomeata@debian.org>, Clint Adams <clint@debian.org>
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Build-Depends:
-  debhelper (>= 10),
+  debhelper-compat (= 12),
   haskell-devscripts-minimal <!cross>,
   devscripts,
   grep-dctrl,
   pkg-config,
-  ghc:native (>= 8.4),
+  ghc:native (>= 8.6),
   libgmp-dev,
-  llvm-6.0 [arm64 armel armhf],
+  llvm-9 [arm64 armel armhf],
   libffi-dev,
   libncurses5-dev,
   python3-sphinx <!cross>,
@@ -29,7 +30,7 @@
 Package: ghc
 Architecture: any
 Depends:
-  llvm-6.0 [arm64 armel armhf],
+  llvm-9 [arm64 armel armhf],
   gcc,
   libgmp-dev,
   libffi-dev,
@@ -52,7 +53,7 @@
 Conflicts: ghc6 (<< 7), ghc-dynamic (<< 7.8)
 Breaks: cabal-install (<< 1.22), haskell-devscripts (<< 0.8.13),
  ghc-doc (<< 7.10), ghc-haddock (<< 7.10), ${conflicting-devs}
-Suggests: perl, ghc-prof, ghc-doc, haskell-doc, llvm-6.0
+Suggests: perl, ghc-prof, ghc-doc, haskell-doc, llvm-9
 Description: The Glasgow Haskell Compilation system
  The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
  Haskell.

=== debian/rules ===
--- 
+++ 
@@ -35,8 +35,7 @@
 
 ProjectVersion=$(shell cat VERSION)
 
-GHC=$(firstword $(shell bash -c "type -p ghc"))
-EXTRA_CONFIGURE_FLAGS +=--with-ghc="$(GHC)"
+export GHC=$(firstword $(shell bash -c "type -p ghc"))
 
 DEB_HOOGLE_TXT_DIR = /usr/lib/ghc-doc/hoogle/
 
@@ -56,7 +55,7 @@
 endif
 
 %:
-ifneq (,$(filter s390x, $(DEB_HOST_ARCH)))
+ifneq (,$(filter s390x arm64, $(DEB_HOST_ARCH)))
 	# Build fails with out-of-memory on Ubuntu's s390x builders.
 	# Setting `ggc-min-expand=10` doesn't solve this.
 	# For now, reduce number of parallel jobs.
@@ -92,7 +91,7 @@
 	# See https://gitlab.haskell.org/ghc/ghc/issues/16998
 	patch -p1 < debian/patches/Disable-unboxed-arrays.patch
 endif
-ifneq (,$(filter mips mipsel mips64el s390x, $(DEB_HOST_ARCH)))
+ifneq (,$(filter mips mipsel s390x, $(DEB_HOST_ARCH)))
 	echo "SRC_HC_OPTS     += -optc--param -optcggc-min-expand=10" >> mk/build.mk
 endif
 ifneq (,$(filter mips64el, $(DEB_HOST_ARCH)))
@@ -193,3 +192,4 @@
 	mkdir -p debian/tmp/var/lib/ghc
 	# Old directories for symlink-workaround. Remove once all libraries use new path
 	mv debian/tmp/usr/lib/ghc/package.conf.d \
+	   debian/tmp/var/lib/ghc/
